import { CompensationType } from "../../enums/compensation-type";
import { PeriodType } from "../../enums/period-type";
import { AdjustmentReason } from "../adjustment-reason/adjustment-reason";
import { CompensationDto } from "./compensation-dto";
import { Employee } from "../employee";
import { Situation } from "../situation";
import { Workschedule } from "../workschedule";
export declare class Compensation {
    id?: string;
    employee: Employee;
    startDate: Date;
    endDate: Date;
    intervalStart?: Date;
    intervalEnd?: Date;
    compensationType: CompensationType;
    periodType?: PeriodType;
    numberOfHours?: number;
    situation: Situation;
    workschedule?: Workschedule;
    adjustmentReason?: AdjustmentReason;
    createdBy?: string;
    createdDate?: Date;
    lastModifiedBy?: string;
    lastModifiedDate?: Date;
    custom?: any;
    static fromDto(compensationDto: CompensationDto, originEntity?: string): Compensation;
    static toDto(compensation: Compensation, originEntity?: string): CompensationDto;
    private static convertMinuteToTime;
}
