import { ClockingEventToleranceType } from "../../enums/clocking-event-tolerance-type";
import { ConsiderClockingEventIntervalType } from "../../enums/consider-clocking-event-interval-type";
import { VerifiedDaysControlType } from "../../enums/verified-days-control-type";
import { RetroactiveAdjustmentType } from "../../enums/retroactive-adjustment-type";
import { Situation } from "../situation/situation";
import { TimeEvaluationDefinitionDto } from "./time-evaluation-definition-dto";
export declare class TimeEvaluationDefinition {
    id?: string;
    code: number;
    name: string;
    useWorkscheduleDayOff?: boolean;
    verifiedDaysControl?: VerifiedDaysControlType;
    controlAdjustmentReason?: boolean;
    controlObservation?: boolean;
    daysResume?: number;
    clockingEventTolerance?: ClockingEventToleranceType;
    retroactiveAdjustment?: RetroactiveAdjustmentType;
    evaluateIncompleteJourney?: boolean;
    incompleteJourneySituation?: Situation;
    numberOfDaysAdjustment?: number;
    calculateHolidayAbsenceRotationWorkshift?: boolean;
    considerClockingEventInterval?: ConsiderClockingEventIntervalType;
    clockingEventInterval?: number;
    schedulingOverlapsHoliday?: boolean;
    limitDaysBackwardScheduling?: number;
    bridgeOverlapsWorkscheduleChange?: boolean;
    allowClockingEventModificationBeforeTransference?: boolean;
    calculateReadiness?: boolean;
    discountHoursWorkedReadiness?: boolean;
    expirationDays?: number;
    limitOfDaysAfterPointClosing?: number;
    blockPendingAfterExpires?: boolean;
    allowsTakeLedgerPending?: boolean;
    allowsCompleteUntreatedPending?: boolean;
    createdBy?: string;
    createdDate?: Date;
    lastModifiedBy?: string;
    lastModifiedDate?: Date;
    custom?: any;
    static fromDto(timeEvaluationDefinitionDto: TimeEvaluationDefinitionDto, originEntity?: string): TimeEvaluationDefinition;
    static toDto(timeEvaluationDefinition: TimeEvaluationDefinition, originEntity?: string): TimeEvaluationDefinitionDto;
}
