import { AfterViewInit, OnDestroy, OnInit, TemplateRef } from "@angular/core";
import { FormBuilder, FormGroup } from "@angular/forms";
import { ActivatedRoute, Router } from "@angular/router";
import { TranslateService } from "@ngx-translate/core";
import { FormField } from "@seniorsistemas/angular-components";
import { HotkeysService } from "angular2-hotkeys";
import { ConfirmationService } from "primeng/api";
import { MessageService } from "primeng/api";
import { Observable } from "rxjs";
import { EmployeeScheduleData } from "../../../core/dtos/employee-schedule-data";
import { BridgeService } from "../../../core/entities/bridge/bridge.service";
import { CompanyClockingEventIndicationsService } from "../../../core/entities/company-clocking-event-indications/company-clocking-event-indications.service";
import { Employee } from "../../../core/entities/employee/employee";
import { EmployeeService } from "../../../core/entities/employee/employee.service";
import { FocusService } from "../../../shared/focus/focus.service";
import { FieldCustomizationService } from "../../../shared/services/field-customization.service";
export declare class BridgeFormComponent implements OnInit, OnDestroy, AfterViewInit {
    private companyClockingEventIndicationsService;
    private bridgeService;
    private router;
    private route;
    private messageService;
    private confirmationService;
    private formBuilder;
    private translate;
    private hotkeysService;
    private fieldCustomization;
    private focusService;
    private employeeService;
    private static EMPLOYEE;
    private static ORIGIN_DATE;
    localeConfig: any;
    currencyLocaleOptions: any;
    permissions: any;
    allPermissions: any;
    formGroup: FormGroup;
    loading: boolean;
    mainPanelCollapsed: boolean;
    contractTypeOptions: {
        label: string;
        value: string;
    }[];
    employeeLookupSuggestions: Employee[];
    employeeLookupDisplayFields: string[];
    employeeAdvancedDisplayFields: string[];
    employeeLookupSeparator: string;
    employeeSearchFields: FormField[];
    employeeSearchGridFields: FormField[];
    employeeSearchGridData: Employee[];
    employeeSearchTotalRecords: number;
    bridge: any;
    customTemplate: TemplateRef<any>;
    customFormFields: TemplateRef<any>;
    cacheLimitDaysBackwardScheduling: Map<string, Date>;
    onSubmitObservable: Observable<any>;
    onLockedEmployeeChanges: Observable<EmployeeScheduleData>;
    lockedEmployee: EmployeeScheduleData;
    private onClose;
    private onLoadFormSubject;
    onCloseObservable: Observable<boolean>;
    onLoadForm: Observable<boolean>;
    private routeParams;
    private ngUnsubscribe;
    constructor(companyClockingEventIndicationsService: CompanyClockingEventIndicationsService, bridgeService: BridgeService, router: Router, route: ActivatedRoute, messageService: MessageService, confirmationService: ConfirmationService, formBuilder: FormBuilder, translate: TranslateService, hotkeysService: HotkeysService, fieldCustomization: FieldCustomizationService, focusService: FocusService, employeeService: EmployeeService);
    ngOnInit(): void;
    patchValuesAndUpdateSuggestions(value: any, result: any): void;
    private loadLockedEmployee;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    setHotkeys(): void;
    isNew(): boolean;
    onRouteParamsChange(params: any): void;
    updateSuggestions(value: any): void;
    getSuggestionValue(displayFields: string[], ownerEntity: string, value: any, separator: string): any;
    onRouteDataChange(data: any): void;
    onCancel(): void;
    onSendFile(filesToDelete: any, filesToCommit: any[]): Observable<{}>;
    onSave(): void;
    finishOperation(): void;
    onDelete(): void;
    getProp(obj: any, path: any): any;
    private loadLabelFromEnum;
    private loadEnumFromLabel;
    onEmployeeLookupRequest(value: string): void;
    onEmployeeSearchRequest(event: any): void;
    private getFormGroup;
    private getEmployeeSearchFields;
    private getEmployeeSearchGridFields;
    private goBack;
    private validateAllFormFields;
    private getSaveObservable;
    private getDeleteObservable;
    private validateVisualization;
    private validLimitDaysBackwardScheduling;
    private startDateIsBeforeEndDate;
    private addMessage;
    private disableFieldsOnEdit;
}
