import { AfterViewInit, OnDestroy, OnInit, Renderer2, TemplateRef } from "@angular/core";
import { FormBuilder, FormGroup } from "@angular/forms";
import { ActivatedRoute, Router } from "@angular/router";
import { TranslateService } from "@ngx-translate/core";
import { DynamicConfig, FormField } from "@seniorsistemas/angular-components";
import { HotkeysService } from "angular2-hotkeys";
import { ConfirmationService, MessageService } from "primeng/api";
import { Observable } from "rxjs";
import { FocusService } from "../../../shared/focus/focus.service";
import { FieldCustomizationService } from "../../../shared/services/field-customization.service";
import { EmployeeScheduleData } from "../../../core/dtos/employee-schedule-data";
import { Employee } from "../../../core/entities/employee/employee";
import { EmployeeService } from "../../../core/entities/employee/employee.service";
import { OvertimeAuthorizationService } from "../../../core/entities/overtime-authorization/overtime-authorization.service";
export declare class OvertimeAuthorizationFormComponent implements OnInit, OnDestroy, AfterViewInit {
    private overtimeAuthorizationService;
    private router;
    private route;
    private messageService;
    private confirmationService;
    private formBuilder;
    private translate;
    private hotkeysService;
    private fieldCustomization;
    private focusService;
    private renderer;
    private employeeService;
    localeConfig: any;
    currencyLocaleOptions: any;
    permissions: any;
    allPermissions: any;
    formGroup: FormGroup;
    loading: boolean;
    mainPanelCollapsed: boolean;
    contractTypeOptions: {
        label: string;
        value: string;
    }[];
    employeeLookupSuggestions: Employee[];
    employeeLookupDisplayFields: string[];
    employeeAdvancedDisplayFields: string[];
    employeeLookupSeparator: string;
    employeeSearchFields: FormField[];
    employeeSearchGridFields: FormField[];
    employeeSearchGridData: Employee[];
    employeeSearchTotalRecords: number;
    overtimeAuthorization: any;
    authorizerLookupSuggestions: Employee[];
    authorizerLookupDisplayFields: string[];
    authorizerAdvancedDisplayFields: string[];
    authorizerLookupSeparator: string;
    authorizerSearchFields: FormField[];
    authorizerSearchGridFields: FormField[];
    authorizerSearchGridData: Employee[];
    authorizerSearchTotalRecords: number;
    customTemplate: TemplateRef<any>;
    customFormFields: TemplateRef<any>;
    onSubmitObservable: Observable<any>;
    onLockedEmployeeChanges: Observable<EmployeeScheduleData>;
    lockedEmployee: EmployeeScheduleData;
    private onClose;
    private onLoadFormSubject;
    onCloseObservable: Observable<boolean>;
    onLoadForm: Observable<boolean>;
    dateAndTimeConfigs: DynamicConfig[];
    private routeParams;
    private ngUnsubscribe;
    constructor(overtimeAuthorizationService: OvertimeAuthorizationService, router: Router, route: ActivatedRoute, messageService: MessageService, confirmationService: ConfirmationService, formBuilder: FormBuilder, translate: TranslateService, hotkeysService: HotkeysService, fieldCustomization: FieldCustomizationService, focusService: FocusService, renderer: Renderer2, employeeService: EmployeeService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    setHotkeys(): void;
    isNew(): boolean;
    onRouteParamsChange(params: any): void;
    updateSuggestions(value: any): void;
    getSuggestionValue(displayFields: string[], ownerEntity: string, value: any, separator: string): any;
    onRouteDataChange(data: any): void;
    onCancel(): void;
    onSendFile(filesToDelete: any, filesToCommit: any[]): Observable<{}>;
    onSave(): void;
    onDelete(): void;
    finishOperation(): void;
    getProp(obj: any, path: any): any;
    private loadLabelFromEnum;
    private loadEnumFromLabel;
    onEmployeeLookupRequest(value: string): void;
    onEmployeeSearchRequest(event: any): void;
    onAuthorizerLookupRequest(value: string): void;
    onAuthorizerSearchRequest(event: any): void;
    private getFormGroup;
    private getEmployeeSearchFields;
    private getEmployeeSearchGridFields;
    private getAuthorizerSearchFields;
    private getAuthorizerSearchGridFields;
    private goBack;
    private validateAllFormFields;
    private getSaveObservable;
    private getDeleteObservable;
    private validateVisualization;
    private startTimeIsBeforeEndTime;
    private startDateIsBeforeOrEqualToEndDate;
    private addMessage;
    patchValuesAndUpdateSuggestions(value: any, result: any): void;
    private loadLockedEmployee;
    private disableFieldsOnEdit;
}
