import { AfterViewInit, OnDestroy, OnInit, TemplateRef } from "@angular/core";
import { FormBuilder, FormGroup } from "@angular/forms";
import { ActivatedRoute, Router } from "@angular/router";
import { TranslateService } from "@ngx-translate/core";
import { DynamicConfig, FormField } from "@seniorsistemas/angular-components";
import { HotkeysService } from "angular2-hotkeys";
import { ConfirmationService, MessageService } from "primeng/api";
import { Observable } from "rxjs";
import { Employee } from "../../../core/entities/employee";
import { EmployeeService } from "../../../core/entities/employee/employee.service";
import { EmployeeScheduleData } from "../../../core/dtos/employee-schedule-data";
import { ReadinessService } from "../../../core/entities/readiness/readiness.service";
import { Situation } from "../../../core/entities/situation/situation";
import { SituationService } from "../../../core/entities/situation/situation.service";
import { FocusService } from "../../../shared/focus/focus.service";
import { FieldCustomizationService } from "../../../shared/services/field-customization.service";
export declare class ReadinessFormComponent implements OnInit, OnDestroy, AfterViewInit {
    private readinessService;
    private router;
    private route;
    private messageService;
    private confirmationService;
    private formBuilder;
    private translate;
    private hotkeysService;
    private fieldCustomization;
    private focusService;
    private employeeService;
    private situationService;
    localeConfig: any;
    currencyLocaleOptions: any;
    permissions: any;
    allPermissions: any;
    formGroup: FormGroup;
    loading: boolean;
    mainPanelCollapsed: boolean;
    contractTypeOptions: {
        label: string;
        value: string;
    }[];
    employeeLookupSuggestions: Employee[];
    employeeLookupDisplayFields: string[];
    employeeAdvancedDisplayFields: string[];
    employeeLookupSeparator: string;
    employeeSearchFields: FormField[];
    employeeSearchGridFields: FormField[];
    employeeSearchGridData: Employee[];
    employeeSearchTotalRecords: number;
    readiness: any;
    situationLookupSuggestions: Situation[];
    situationLookupDisplayFields: string[];
    situationAdvancedDisplayFields: string[];
    situationLookupSeparator: string;
    situationSearchFields: FormField[];
    situationSearchGridFields: FormField[];
    situationSearchGridData: Situation[];
    situationSearchTotalRecords: number;
    customTemplate: TemplateRef<any>;
    customFormFields: TemplateRef<any>;
    onSubmitObservable: Observable<any>;
    onLockedEmployeeChanges: Observable<EmployeeScheduleData>;
    lockedEmployee: EmployeeScheduleData;
    private onClose;
    private onLoadFormSubject;
    onCloseObservable: Observable<boolean>;
    onLoadForm: Observable<boolean>;
    dateAndTimeConfigs: DynamicConfig[];
    private routeParams;
    private ngUnsubscribe;
    constructor(readinessService: ReadinessService, router: Router, route: ActivatedRoute, messageService: MessageService, confirmationService: ConfirmationService, formBuilder: FormBuilder, translate: TranslateService, hotkeysService: HotkeysService, fieldCustomization: FieldCustomizationService, focusService: FocusService, employeeService: EmployeeService, situationService: SituationService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    patchValuesAndUpdateSuggestions(value: any, result: any): void;
    private loadLockedEmployee;
    setHotkeys(): void;
    isNew(): boolean;
    onRouteParamsChange(params: any): void;
    updateSuggestions(value: any): void;
    getSuggestionValue(displayFields: string[], ownerEntity: string, value: any, separator: string): any;
    onRouteDataChange(data: any): void;
    onCancel(): void;
    onSendFile(filesToDelete: any, filesToCommit: any[]): Observable<{}>;
    onSave(): void;
    onDelete(): void;
    finishOperation(): void;
    getProp(obj: any, path: any): any;
    private loadLabelFromEnum;
    private loadEnumFromLabel;
    onEmployeeLookupRequest(value: string): void;
    onEmployeeSearchRequest(event: any): void;
    onSituationLookupRequest(value: string): void;
    onSituationSearchRequest(event: any): void;
    private getFormGroup;
    private getEmployeeSearchFields;
    private getEmployeeSearchGridFields;
    private getSituationSearchFields;
    private getSituationSearchGridFields;
    private goBack;
    private validateAllFormFields;
    private getSaveObservable;
    private getDeleteObservable;
    private validateVisualization;
    private startTimeIsBeforeEndTime;
    private startDateIsBeforeOrEqualToEndDate;
    private addMessage;
    private disableFieldsOnEdit;
}
