import { AfterViewInit, OnDestroy, OnInit, TemplateRef } from "@angular/core";
import { FormBuilder, FormGroup } from "@angular/forms";
import { ActivatedRoute, Router } from "@angular/router";
import { TranslateService } from "@ngx-translate/core";
import { FormField } from "@seniorsistemas/angular-components";
import { HotkeysService } from "angular2-hotkeys";
import { ConfirmationService } from "primeng/api";
import { MessageService } from "primeng/api";
import { InputSwitch } from "primeng/inputswitch";
import { Observable } from "rxjs";
import { Employee } from "../../../core/entities/employee/employee";
import { EmployeeService } from "../../../core/entities/employee/employee.service";
import { EmployeeScheduleData } from "../../../core/dtos/employee-schedule-data";
import { TimeEvaluationHistoryService } from "../../../core/entities/time-evaluation-history/time-evaluation-history.service";
import { TimeEvaluationSituationDefinition } from "../../../core/entities/time-evaluation-situation-definition/time-evaluation-situation-definition";
import { TimeEvaluationSituationDefinitionService } from "../../../core/entities/time-evaluation-situation-definition/time-evaluation-situation-definition.service";
import { Article62CltType } from "../../../core/enums/article-62-clt-type";
import { TimeEvaluationType } from "../../../core/enums/time-evaluation-type";
import { FocusService } from "../../../shared/focus/focus.service";
import { FieldCustomizationService } from "../../../shared/services/field-customization.service";
export declare class TimeEvaluationHistoryFormComponent implements OnInit, OnDestroy, AfterViewInit {
    private timeEvaluationHistoryService;
    private router;
    private route;
    private messageService;
    private confirmationService;
    private formBuilder;
    private translate;
    private hotkeysService;
    private fieldCustomization;
    private focusService;
    private employeeService;
    private timeEvaluationSituationDefinitionService;
    localeConfig: any;
    currencyLocaleOptions: any;
    permissions: any;
    allPermissions: any;
    formGroup: FormGroup;
    loading: boolean;
    mainPanelCollapsed: boolean;
    timeEvaluationType: {
        label: string;
        value: TimeEvaluationType;
    }[];
    article62CltType: {
        label: string;
        value: Article62CltType;
    }[];
    contractTypeOptions: {
        label: string;
        value: string;
    }[];
    employeeLookupSuggestions: Employee[];
    employeeLookupDisplayFields: string[];
    employeeAdvancedDisplayFields: string[];
    employeeLookupSeparator: string;
    employeeSearchFields: FormField[];
    employeeSearchGridFields: FormField[];
    employeeSearchGridData: Employee[];
    employeeSearchTotalRecords: number;
    situationDefinitionLookupSuggestions: TimeEvaluationSituationDefinition[];
    situationDefinitionLookupDisplayFields: string[];
    situationDefinitionAdvancedDisplayFields: string[];
    situationDefinitionLookupSeparator: string;
    situationDefinitionSearchFields: FormField[];
    situationDefinitionSearchGridFields: FormField[];
    situationDefinitionSearchGridData: TimeEvaluationSituationDefinition[];
    situationDefinitionSearchTotalRecords: number;
    customTemplate: TemplateRef<any>;
    customFormFields: TemplateRef<any>;
    clockingAdjustmentInputSwitch: InputSwitch;
    enableFileds: TimeEvaluationHistoryValidationFields;
    controlOfFormFields: Map<TimeEvaluationType, TimeEvaluationHistoryValidationFields>;
    onSubmitObservable: Observable<any>;
    onLockedEmployeeChanges: Observable<EmployeeScheduleData>;
    lockedEmployee: EmployeeScheduleData;
    private onClose;
    private onLoadFormSubject;
    onCloseObservable: Observable<boolean>;
    onLoadForm: Observable<boolean>;
    private routeParams;
    private ngUnsubscribe;
    constructor(timeEvaluationHistoryService: TimeEvaluationHistoryService, router: Router, route: ActivatedRoute, messageService: MessageService, confirmationService: ConfirmationService, formBuilder: FormBuilder, translate: TranslateService, hotkeysService: HotkeysService, fieldCustomization: FieldCustomizationService, focusService: FocusService, employeeService: EmployeeService, timeEvaluationSituationDefinitionService: TimeEvaluationSituationDefinitionService);
    ngOnInit(): void;
    private loadLockedEmployee;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    setHotkeys(): void;
    isNew(): boolean;
    onRouteParamsChange(params: any): void;
    updateSuggestions(value: any): void;
    getSuggestionValue(displayFields: string[], ownerEntity: string, value: any, separator: string): any;
    onRouteDataChange(data: any): void;
    onCancel(): void;
    onSendFile(filesToDelete: any, filesToCommit: any[]): Observable<{}>;
    onSave(): void;
    onDelete(): void;
    getProp(obj: any, path: any): any;
    private loadLabelFromEnum;
    private loadEnumFromLabel;
    onEmployeeLookupRequest(value: string): void;
    onEmployeeSearchRequest(event: any): void;
    onSituationDefinitionLookupRequest(value: string): void;
    onSituationDefinitionSearchRequest(event: any): void;
    private getFormGroup;
    private getEmployeeSearchFields;
    private getEmployeeSearchGridFields;
    private getSituationDefinitionSearchFields;
    private getSituationDefinitionSearchGridFields;
    private goBack;
    private validateAllFormFields;
    private getSaveObservable;
    private getDeleteObservable;
    private validateVisualization;
    private enableAndDisableFields;
    private enableOrDisableField;
    getClockingAdjustment(): string;
    getApproveOwnClocking(): string;
    getArticle62Clt(): string;
    private addMessage;
    setFalseValuesIfProcessAdjustedDisabled(): void;
    setFalseValueIfClockingAdjustmentDisabled(): void;
    verifyRequired(): boolean;
    private disableFieldsOnEdit;
}
interface TimeEvaluationHistoryValidationFields {
    article62Clt: boolean;
}
export {};
